package com.emato.cus.supervise.biz.acqGoodsMoveSchedule.up;

import com.emato.cus.supervise.biz.CusData;
import com.emato.cus.supervise.constant.EmtRecordTimeEnum;
import com.emato.cus.supervise.domainCus.CusAcqGoodsMove05;
import com.emato.cus.supervise.service.cus.CusAcqGoodsMoveService05;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 货物库位移动数据 业务 CUS
 * @author zengjunlin
 * @version 1.0
 * 2018-02-03 15:23
 */
@Component
public class AcqGoodsMoveUpCusData implements CusData {


    private static final Logger logger = LoggerFactory.getLogger(AcqGoodsMoveUpCusData.class);

    @Autowired
    private CusAcqGoodsMoveService05 cusAcqGoodsMoveService05;

    private static final String DATA_TYPE_INFO = "[" + EmtRecordTimeEnum.ACQ_GOODS_MOVE_UP.getCode() + "]" + EmtRecordTimeEnum.ACQ_GOODS_MOVE_UP.getName();


    @Override
    public int insertCus(List<?> list) {
        logger.info("---------- 货物库位移动数据::写入本次监控数据开始 --------------------");

        List<CusAcqGoodsMove05> cusList = (List<CusAcqGoodsMove05>) list;

        int result = cusAcqGoodsMoveService05.addCusAcqGoodsMove05(cusList);

        logger.info("---【" + DATA_TYPE_INFO + "】写入监控数据:{} 条", result);

        logger.info("---------- 货物库位移动数据::写入本次监控数据结束 --------------------");
        return result;
    }

}
