package com.emato.cus.supervise.biz.acqInventoryInfo;

import com.emato.cus.supervise.biz.CusData;
import com.emato.cus.supervise.constant.EmtRecordTimeEnum;
import com.emato.cus.supervise.domainCus.CusAcqInventoryInfo03;
import com.emato.cus.supervise.service.cus.CusAcqInventoryInfoService03;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author zengjunlin
 * @version 1.0
 * 2018-02-02 09:44
 */
@Component
public class AcqInventoryInfoCusData implements CusData {

    private static final Logger logger = LoggerFactory.getLogger(AcqInventoryInfoCusData.class);

    @Autowired
    private CusAcqInventoryInfoService03 cusAcqInventoryInfoService03;

    private static final String DATA_TYPE_INFO = "[" + EmtRecordTimeEnum.I_ACQ_INVENTORY_INFO.getCode() + "]" + EmtRecordTimeEnum.I_ACQ_INVENTORY_INFO.getName();


    @Override
    public int insertCus(List<?> list) {
        logger.info("---------- 货物库存数据::写入本次监控数据开始 --------------------");

        List<CusAcqInventoryInfo03> cusList = ( List<CusAcqInventoryInfo03>)list;
        int result = cusAcqInventoryInfoService03.addCusAcqInventoryInfo(cusList);

        logger.info("---【" + DATA_TYPE_INFO + "】写入监控数据:{} 条", result);

        logger.info("---------- 货物库存数据::写入本次监控数据结束 --------------------");
        return result;
    }

}
