package com.emato.cus.supervise.biz.acqInventoryInfo;

import com.emato.cus.supervise.biz.OmsData;
import com.emato.cus.supervise.constant.EmtRecordTimeEnum;
import com.emato.cus.supervise.domainOms.OmsAcqInventoryInfo;
import com.emato.cus.supervise.service.wms.impl.OmsAcqInventoryInfoServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;

/**
 *
 * @author zengjunlin
 * @version 1.0
 * 2018-02-02 14:33
 */
@Component
public class AcqInventoryInfoOmsData implements OmsData {

    private static final Logger logger = LoggerFactory.getLogger(AcqInventoryInfoOmsData.class);

    private static final String DATA_TYPE_INFO = "[" + EmtRecordTimeEnum.I_ACQ_INVENTORY_INFO.getCode() + "]" + EmtRecordTimeEnum.I_ACQ_INVENTORY_INFO.getName();

    @Autowired
    private OmsAcqInventoryInfoServiceImpl omsAcqInventoryInfoService;
    /**
     * 获取oms 数据
     *
     * @param merchSnList
     * @return
     */
    @Override
    public List getOmsData(List<String> merchSnList) {
        logger.info("---------- 查询Oms数据开始 --------------------");

        if (merchSnList == null || merchSnList.isEmpty()) {
            String err = "---【" + DATA_TYPE_INFO + "】本次商户编号集合为空.";
            logger.error(err);
            return Collections.EMPTY_LIST;
        }

        List<OmsAcqInventoryInfo> resultList = omsAcqInventoryInfoService.getOmsAcqInventoryInfoList(merchSnList);
        if (resultList == null || resultList.size() == 0) {
            String err = "---【" + DATA_TYPE_INFO + "】获取本次OMS监控数据为空.";
            logger.error(err);
            return Collections.EMPTY_LIST;
        }

        logger.info("---【" + DATA_TYPE_INFO + "】获取本数据{}条.", resultList.size());

        logger.info("---------- 查询Oms数据结束 --------------------");
        return resultList;
    }
}
