package com.emato.cus.supervise.biz.acqShelfLoad.up;

import com.emato.cus.supervise.biz.DataConversion;
import com.emato.cus.supervise.constant.Dict;
import com.emato.cus.supervise.domain.WmsAcqShelfLoad;
import com.emato.cus.supervise.domainCus.CusAcqShelfLoad04;
import com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 *
 * @author zengjunlin
 * @version 1.0
 * 2018-02-03 13:40
 */
@Component
public class AcqShelfLoadUpDataConversion implements DataConversion {


    private final static Logger logger = LoggerFactory.getLogger(AcqShelfLoadUpDataConversion.class);

    /**
     * 企业货物上下架信息组装
     * 外部数据转换
     * @param params
     * @return
     */
    @Override
    public List conversion(Map params) {
        logger.info("开始转换oms，wms 组装cus数据===========================");
        List<WmsAcqShelfLoad> wmsList = (List<WmsAcqShelfLoad>) params.get("wmsList");
        //List<OmsAcqInventoryInfo> omsList = (List<OmsAcqInventoryInfo>) params.get("omsList");
        //final Map<String,OmsAcqInventoryInfo> omsAcqInventoryInfoMap = omsList.stream().collect(Collectors.toMap(k->k.getMerchSn(), v->v));
        List<CusAcqShelfLoad04> cusAcqShelfLoad04List = Lists.newArrayList();
        for (int i = 0; i < wmsList.size(); i++) {
            WmsAcqShelfLoad wmsAcqShelfLoad = wmsList.get(i);
            CusAcqShelfLoad04 cusAcqShelfLoad04 = new CusAcqShelfLoad04();
            cusAcqShelfLoad04.setId(wmsAcqShelfLoad.getId());
            cusAcqShelfLoad04.setGoodsName(wmsAcqShelfLoad.getGoodsName());
            cusAcqShelfLoad04.setCodeTs(wmsAcqShelfLoad.getCodeTs());
            cusAcqShelfLoad04.setFormNoDec(wmsAcqShelfLoad.getFormNoDec());
            cusAcqShelfLoad04.setFormNo(wmsAcqShelfLoad.getFormNo());
            cusAcqShelfLoad04.setSkuNo(wmsAcqShelfLoad.getSkuNo());
            cusAcqShelfLoad04.setGoodsId(wmsAcqShelfLoad.getGoodsId());
            cusAcqShelfLoad04.setgUnit(wmsAcqShelfLoad.getgUnit());
            cusAcqShelfLoad04.setgQty(wmsAcqShelfLoad.getgQty());
            cusAcqShelfLoad04.setLegalUnit(wmsAcqShelfLoad.getLegalUnit());
            cusAcqShelfLoad04.setLegalQty(wmsAcqShelfLoad.getLegalQty());
            cusAcqShelfLoad04.setGoodsModel(wmsAcqShelfLoad.getGoodsModel());
            cusAcqShelfLoad04.setLocalEmsNo(Dict.localEmsNo);
            cusAcqShelfLoad04.setSeatNo(wmsAcqShelfLoad.getSeatNo());
            cusAcqShelfLoad04.setShelfLoadTime(wmsAcqShelfLoad.getShelfLoadTime());
            cusAcqShelfLoad04.setShelfLoadType(wmsAcqShelfLoad.getShelfLoadType());
            cusAcqShelfLoad04.setStoreCompanyName(Dict.storeCompanyName);
            cusAcqShelfLoad04.setStoreUscCode(Dict.storeUscCode);
            cusAcqShelfLoad04.setStoreCustomsCode(Dict.storeCustomsCode);
            cusAcqShelfLoad04.setStoreCode(Dict.storeCode);
            cusAcqShelfLoad04.setCreateTime(LocalDateTime.now());
            cusAcqShelfLoad04List.add(cusAcqShelfLoad04);
        }
        logger.info("转换oms，wms 组装cus数据结束===========================");
        return cusAcqShelfLoad04List;
    }

}
