package com.emato.cus.supervise.config;

import org.springframework.boot.bind.RelaxedPropertyResolver;
import org.springframework.context.EnvironmentAware;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.core.env.PropertyResolver;

/**
 * Spring property Resolver
 *
 * @author Scott Chen
 * @date 2017/4/23
 */
@Configuration
public class SpringPropertyResolverConfig implements EnvironmentAware {

    private PropertyResolver propertyResolver;

    @Override
    public void setEnvironment(Environment environment) {
        propertyResolver = new RelaxedPropertyResolver(environment);
    }

    @Bean
    public PropertyResolver propertyResolver() {
        return propertyResolver;
    }
}
