package com.emato.cus.supervise.config.servlet;

import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.filter.CharacterEncodingFilter;

/**
 * Servlet 配置
 *
 * @author Scott Chen
 * @date 2017/5/4
 */
@Configuration
public class ServletConfig {

    /**
     * 字符过滤
     * @return
     */
    @Bean
    public FilterRegistrationBean characterEncodingFilter() {
        FilterRegistrationBean filterBean = new FilterRegistrationBean();
        filterBean.setName("characterEncoding");
        filterBean.setFilter(new CharacterEncodingFilter());
        filterBean.addInitParameter("encoding", "UTF-8");
        filterBean.addInitParameter("forceEncoding", "true");
        filterBean.addUrlPatterns("/*");
        return filterBean;
    }

}
