package com.emato.cus.supervise.msg;

/**
 * 自定义异常
 *
 * @author Scott Chen
 * @date 2017/3/22
 */
public class MessageException extends RuntimeException {

    private static final long serialVersionUID = -1422580005904561463L;

    private String code;
    private String msg;

    public MessageException() {
        super();
    }

    public MessageException(String msg) {
        super(msg);
        this.msg = msg;
    }

    public MessageException(String code, String msg) {
        super(msg);
        this.code = code;
        this.msg = msg;
    }

    public MessageException(String code, String msg, Throwable cause) {
        super(msg, cause);
        this.code = code;
        this.msg = msg;
    }

    public MessageException(String msg, Throwable cause) {
        super(msg, cause);
        this.msg = msg;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
